From 896b438b7d0ae27fa6be2481bf44284b511f656c Mon Sep 17 00:00:00 2001
From: rlarjsdn122 <rlarjsdn122@naver.com>
Date: Mon, 26 Feb 2018 03:37:47 +0900
Subject: [[PATCH website] Add Korean translations of News in 2018] Indepent on
 before two fetches I sent.News in 2018

Signed-off-by: rlarjsdn122 <rlarjsdn122@naver.com>
---
 news/ko/2018010201.xml | 14 ++++++++++++++
 news/ko/2018010501.xml | 12 ++++++++++++
 news/ko/2018011201.xml | 12 ++++++++++++
 news/ko/2018011801.xml | 16 ++++++++++++++++
 news/ko/2018020201.xml | 16 ++++++++++++++++
 5 files changed, 70 insertions(+)
 create mode 100644 news/ko/2018010201.xml
 create mode 100644 news/ko/2018010501.xml
 create mode 100644 news/ko/2018011201.xml
 create mode 100644 news/ko/2018011801.xml
 create mode 100644 news/ko/2018020201.xml

diff --git a/news/ko/2018010201.xml b/news/ko/2018010201.xml
new file mode 100644
index 00000000..8fa8d729
--- /dev/null
+++ b/news/ko/2018010201.xml
@@ -0,0 +1,14 @@
+<news>
+<date>1월  2일 2018</date>
+<title>와인 2.0.4 배포</title>
+<body>
+<p> The Wine maintenance release 2.0.4(을)를 내려받을 수 있습니다.</p>
+<p> <a href="{$root}/announce/2.0.4">이 판</a>의 변경 및 개선점:
+<ul>
+  <li>여러 오류 고침</li>
+  <li>Updates to the National Language Support files</li>
+  <li>Documentation updates</li>
+</ul>
+<p>원시 부호는 <a href="//dl.winehq.org/wine/source/2.0/wine-2.0.4.tar.xz">에서 받을 수 있습니다.</a>
+실행 파일이 빌드되는 중이며, 곧 <a href="{$root}/download">여기</a>에서 내려받을 수 있습니다.
+</p></body></news>
diff --git a/news/ko/2018010501.xml b/news/ko/2018010501.xml
new file mode 100644
index 00000000..b85c6f75
--- /dev/null
+++ b/news/ko/2018010501.xml
@@ -0,0 +1,12 @@
+<news>
+<date>1월  5일 2018</date>
+<title>와인 3.0-rc5 배포</title>
+<body>
+<p> 와인 개발자판 3.0-rc5(을)를 내려받을 수 있습니다.</p>
+<p> <a href="{$root}/announce/3.0-rc5">이 판</a>의 변경 및 개선점:
+<ul>
+  <li>오류만 고쳐졌으며, 원시 부호는 변하지 않았습니다..</li>
+</ul>
+<p>원시 부호는 <a href="//dl.winehq.org/wine/source/3.0/wine-3.0-rc5.tar.xz">에서 받을 수 있습니다.</a>
+실행 파일이 빌드되는 중이며, 곧 <a href="{$root}/download">여기</a>에서 내려받을 수 있습니다.
+</p></body></news>
diff --git a/news/ko/2018011201.xml b/news/ko/2018011201.xml
new file mode 100644
index 00000000..b8549912
--- /dev/null
+++ b/news/ko/2018011201.xml
@@ -0,0 +1,12 @@
+<news>
+<date>1월 12일 2018</date>
+<title>와인 3.0-rc6 배포</title>
+<body>
+<p> 와인 개발자판 3.0-rc6(을)를 내려받을 수 있습니다.</p>
+<p> <a href="{$root}/announce/3.0-rc6">이 판</a>의 변경 및 개선점:
+<ul>
+  <li>오류만 고쳐졌으며, 원시 부호는 변하지 않았습니다..</li>
+</ul>
+<p>원시 부호는 <a href="//dl.winehq.org/wine/source/3.0/wine-3.0-rc6.tar.xz">에서 받을 수 있습니다.</a>
+실행 파일이 빌드되는 중이며, 곧 <a href="{$root}/download">여기</a>에서 내려받을 수 있습니다.
+</p></body></news>
diff --git a/news/ko/2018011801.xml b/news/ko/2018011801.xml
new file mode 100644
index 00000000..bc97b4f1
--- /dev/null
+++ b/news/ko/2018011801.xml
@@ -0,0 +1,16 @@
+<news>
+<date>1월 18일 2018</date>
+<title>와인 3.0 배포</title>
+<body>
+<p> 와인 제작진이 자랑스럽게 공개하는 새 안정판인 와인 3.0(을)를 내려받을 수 있습니다.</p>
+<p> This release represents a year of development effort and over 6,000 individual changes. It contains a large number of improvements that are listed in the <a href="{$root}/announce/3.0">release notes</a>. The main highlights are:</p>
+<ul>
+  <li>Direct3D 10 and 11 support.</li>
+  <li>The Direct3D command stream.</li>
+  <li>The Android graphics driver.</li>
+  <li>Improved DirectWrite and Direct2D support.</li>
+</ul>
+<p> Once again, because of the annual release schedule, a number of features that are being worked on have been deferred to the next development cycle. This includes in particular Direct3D 12 and Vulkan support, as well as OpenGL ES support to enable Direct3D on Android.</p>
+<p>원시 부호는 <a href="//dl.winehq.org/wine/source/3.0/wine-3.0.tar.xz">에서 받을 수 있습니다.</a>
+실행 파일이 빌드되는 중이며, 곧 <a href="{$root}/download">여기</a>에서 내려받을 수 있습니다.
+</p></body></news>
diff --git a/news/ko/2018020201.xml b/news/ko/2018020201.xml
new file mode 100644
index 00000000..91db8585
--- /dev/null
+++ b/news/ko/2018020201.xml
@@ -0,0 +1,16 @@
+<news>
+<date>February  2일 2018</date>
+<title>와인 3.1 배포</title>
+<body>
+<p> 와인 개발자판 3.1(을)를 내려받을 수 있습니다.</p>
+<p> <a href="{$root}/announce/3.1">이 판</a>의 변경 및 개선점:
+<ul>
+  <li>Kerberos authentication support.</li>
+  <li>Window class redirection for Common Controls 6.</li>
+  <li>다이렉트X11 ARGB 지원.</li>
+  <li>도스 파일을 실행시키기 위해서는 도스박스가 필요합니다.</li>
+  <li>여러 오류 고침.</li>
+</ul>
+<p>원시 부호는 <a href="//dl.winehq.org/wine/source/3.x/wine-3.1.tar.xz">에서 받을 수 있습니다.</a>
+실행 파일이 빌드되는 중이며, 곧 <a href="{$root}/download">여기</a>에서 내려받을 수 있습니다.
+</p></body></news>
-- 
2.16.1.windows.1